Skip to content
Ona Docs

ListMembers

POST/gitpod.v1.OrganizationService/ListMembers

Lists and filters organization members with optional pagination.

Use this method to:

  • View all organization members
  • Monitor member activity
  • Manage team membership

Examples

  • List active members:

    Retrieves active members with pagination.

    organizationId: "b0e12f6c-4c67-429d-a4a6-d9838b5da047"
    pagination:
      pageSize: 20
  • List with pagination:

    Retrieves next page of members.

    organizationId: "b0e12f6c-4c67-429d-a4a6-d9838b5da047"
    pagination:
      pageSize: 50
      token: "next-page-token-from-previous-response"
Query ParametersExpand Collapse
token: optional string
pageSize: optional number
maximum100
minimum0
Body ParametersJSONExpand Collapse
organizationId: string

organization_id is the ID of the organization to list members for

formatuuid
filter: optional object { excludeGroupIds, excludeMembersInAnyTeam, roles, 3 more }
excludeGroupIds: optional array of string

exclude_group_ids excludes members who are already in any of the specified groups

excludeMembersInAnyTeam: optional boolean

exclude_members_in_any_team excludes members who belong to any team in the organization

roles: optional array of OrganizationRole

roles filters members by their organization role

One of the following:
"ORGANIZATION_ROLE_UNSPECIFIED"
"ORGANIZATION_ROLE_ADMIN"
"ORGANIZATION_ROLE_MEMBER"
statuses: optional array of UserStatus

status filters members by their user status

One of the following:
"USER_STATUS_UNSPECIFIED"
"USER_STATUS_ACTIVE"
"USER_STATUS_SUSPENDED"
"USER_STATUS_LEFT"
userIds: optional array of string

user_ids filters the response to only members with the specified user IDs

sort: optional object { field, order }

sort specifies the order of results. When unspecified, the authenticated user is returned first, followed by other members sorted by name ascending. When an explicit sort is specified, results are sorted purely by the requested field without any special handling for the authenticated user.

field: optional "SORT_FIELD_UNSPECIFIED" or "SORT_FIELD_NAME" or "SORT_FIELD_DATE_JOINED"
One of the following:
"SORT_FIELD_UNSPECIFIED"
"SORT_FIELD_NAME"
"SORT_FIELD_DATE_JOINED"
order: optional SortOrder
One of the following:
"SORT_ORDER_UNSPECIFIED"
"SORT_ORDER_ASC"
"SORT_ORDER_DESC"
ReturnsExpand Collapse
members: array of OrganizationMember { email, fullName, loginProvider, 5 more }

members are the members of the organization

email: string
fullName: string
loginProvider: string

login_provider is the login provider the user uses to sign in

memberSince: string

A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one.

All minutes are 60 seconds long. Leap seconds are “smeared” so that no leap second table is needed for interpretation, using a 24-hour linear smear.

The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from RFC 3339 date strings.

Examples

Example 1: Compute Timestamp from POSIX time().

 Timestamp timestamp;
 timestamp.set_seconds(time(NULL));
 timestamp.set_nanos(0);

Example 2: Compute Timestamp from POSIX gettimeofday().

 struct timeval tv;
 gettimeofday(&tv, NULL);

 Timestamp timestamp;
 timestamp.set_seconds(tv.tv_sec);
 timestamp.set_nanos(tv.tv_usec * 1000);

Example 3: Compute Timestamp from Win32 GetSystemTimeAsFileTime().

 FILETIME ft;
 GetSystemTimeAsFileTime(&ft);
 UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;

 // A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
 // is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
 Timestamp timestamp;
 timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
 timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));

Example 4: Compute Timestamp from Java System.currentTimeMillis().

 long millis = System.currentTimeMillis();

 Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
     .setNanos((int) ((millis % 1000) * 1000000)).build();

Example 5: Compute Timestamp from Java Instant.now().

 Instant now = Instant.now();

 Timestamp timestamp =
     Timestamp.newBuilder().setSeconds(now.getEpochSecond())
         .setNanos(now.getNano()).build();

Example 6: Compute Timestamp from current time in Python.

 timestamp = Timestamp()
 timestamp.GetCurrentTime()

JSON Mapping

In JSON format, the Timestamp type is encoded as a string in the RFC 3339 format. That is, the format is “{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z” where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The “Z” suffix indicates the timezone (“UTC”); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by “Z”) when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset).

For example, “2017-01-15T01:30:15.01Z” encodes 15.01 seconds past 01:30 UTC on January 15, 2017.

In JavaScript, one can convert a Date object to this format using the standard toISOString() method. In Python, a standard datetime.datetime object can be converted to this format using strftime with the time format spec ‘%Y-%m-%dT%H:%M:%S.%fZ’. Likewise, in Java, one can use the Joda Time’s ISODateTimeFormat.dateTime() to obtain a formatter capable of generating timestamps in this format.

formatdate-time
One of the following:
"ORGANIZATION_ROLE_UNSPECIFIED"
"ORGANIZATION_ROLE_ADMIN"
"ORGANIZATION_ROLE_MEMBER"
status: UserStatus
One of the following:
"USER_STATUS_UNSPECIFIED"
"USER_STATUS_ACTIVE"
"USER_STATUS_SUSPENDED"
"USER_STATUS_LEFT"
userId: string
formatuuid
avatarUrl: optional string

ListMembers

curl https://app.gitpod.io/api/gitpod.v1.OrganizationService/ListMembers \
    -H 'Content-Type: application/json' \
    -H "Authorization: Bearer $GITPOD_API_KEY" \
    -d '{
          "organizationId": "b0e12f6c-4c67-429d-a4a6-d9838b5da047"
        }'
{
  "members": [
    {
      "email": "email",
      "fullName": "fullName",
      "loginProvider": "loginProvider",
      "memberSince": "2019-12-27T18:11:19.117Z",
      "role": "ORGANIZATION_ROLE_UNSPECIFIED",
      "status": "USER_STATUS_UNSPECIFIED",
      "userId": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
      "avatarUrl": "avatarUrl"
    }
  ],
  "pagination": {
    "nextToken": "nextToken"
  },
  "count": {
    "relation": "COUNT_RESPONSE_RELATION_UNSPECIFIED",
    "value": 0
  }
}
Returns Examples
{
  "members": [
    {
      "email": "email",
      "fullName": "fullName",
      "loginProvider": "loginProvider",
      "memberSince": "2019-12-27T18:11:19.117Z",
      "role": "ORGANIZATION_ROLE_UNSPECIFIED",
      "status": "USER_STATUS_UNSPECIFIED",
      "userId": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
      "avatarUrl": "avatarUrl"
    }
  ],
  "pagination": {
    "nextToken": "nextToken"
  },
  "count": {
    "relation": "COUNT_RESPONSE_RELATION_UNSPECIFIED",
    "value": 0
  }
}